from __future__ import division, print_function

import random


PLAY_CHANCE = True
CHANCE = None

CARDS = {
    "paper": ["rock", "rubber"],
    "rock": ["scissors", "glue"],
    "scissors": ["paper"],
    "rubber": ["rock", "scissors", "glue", "water"],
    "glue": ["scissors", "paper", "water"],
    "water": ["rock", "paper", "scissors"],
    }


players = {1:[], 2:[]}

DECK = {
    "paper": 15,
    "rock": 15,
    "scissors": 15,
    "rubber": 6,
    "glue": 9,
    "water": 4,
    }

def build_deck(deckspec):
    deck = []
    for k,v in deckspec.iteritems():
        deck.extend([k]*v)
    random.shuffle(deck)
    return deck


current_deck = build_deck(DECK)
graveyard = []


def run():
    deal_hand(1)
    deal_hand(2)
    while True:
        show_hands()
        your_move()

def deal_hand(player):
    for i in xrange(3):
        deal_card(player)

def deal_card(player):
    global current_deck
    if not current_deck:
        current_deck = graveyard
        random.shuffle(current_deck)
        graveyard = []
    players[player].append(current_deck.pop())

def show_hands():
    print("{:<32}{:>32}".format("Player 1","Player 2"))
    print("{:<32}{:>32}".format(" ".join(players[1]), " ".join(players[2])))
    print()

def your_move():
    global CHANCE
    if PLAY_CHANCE and CHANCE:
        print("Player {}'s Chance!".format(CHANCE))
    x = raw_input("Pick a card: ")
    if x in players[1]:
        play_card(1, x)
        ai = play_card(2)
    else:
        print("You don't have that card you fanny.\n")
        return
    winning_player = battle(x, ai)
    if PLAY_CHANCE:
        if winning_player == CHANCE:
            print("Player {} scores!".format(CHANCE))
        else:
            CHANCE = winning_player
    deal_card(1)
    deal_card(2)
    print()

def play_card(player, card=None):
    if not card:
        card = random.choice(players[player])
    players[player].remove(card)
    graveyard.append(card)
    return card

def battle(card1, card2):
    print("!!!{:>27} vs {:<27}!!!".format(card1, card2))
    if card2 in CARDS[card1]:
        print("Player 1 wins!")
        return 1
    elif card1 in CARDS[card2]:
        print("Player 2 wins!")
        return 2
    else:
        print("Draw.")
        return 0
